<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.billrecord_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
      <template></template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/billrecord/billrecord";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "姓名",
              prop: "userName",
              search: true,
              rules: [{
                required: true,
                message: "请输入用户id",
                trigger: "blur"
              }]
            },
            {
              label: "手机号",
              prop: "userPhone",
              search: true,
              rules: [{
                required: true,
                message: "请输入openId",
                trigger: "blur"
              }]
            },
            {
              label: "活动名称",
              prop: "activityId",
              hide: true,
              display: false,
              rules: [{
                required: true,
                message: "请输入活动id",
                trigger: "blur"
              }]
            },
            {
              label: "价格",
              prop: "price",
              rules: [{
                required: true,
                message: "请输入价格",
                trigger: "blur"
              }]
            },
            {
              label: "礼物id",
              prop: "presentId",
              hide: true,
              display: false,
              rules: [{
                required: true,
                message: "请输入礼物id",
                trigger: "blur"
              }]
            },
            {
              label: "订单礼物的数量",
              prop: "presentCount",
              rules: [{
                required: true,
                message: "请输入订单礼物的数量",
                trigger: "blur"
              }]
            },
            {
              label: "打赏类型",
              prop: "type",
              type: "select",
              dicData: [
                {
                  label: "打赏作品",
                  value: 1
                },
                {
                  label: "打赏作者",
                  value: 2
                },
                {
                  label: "购买积分商品",
                  value: 3
                },
                {
                  label: "代理费",
                  value: 4
                },
                
              ],
              rules: [{
                required: true,
                message: "请输入1：作品打赏 2：作者打赏",
                trigger: "blur"
              }]
            },
            {
              label: "关联type的id",
              prop: "relationId",
              rules: [{
                required: true,
                message: "请输入关联type的id",
                trigger: "blur"
              }]
            },
            {
              label: "支付状态",
              prop: "payStatus",
              search: true,
              type: "select",
              dicData: [
                {
                  label: "待付款",
                  value: 0
                },
                {
                  label: "已付款",
                  value: 1
                },
                {
                  label: "已取消",
                  value: 2
                }
              ],
              rules: [{
                required: true,
                message: "请输入支付状态。0：待付款 1：已付款 2：已取消",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.billrecord_add, false),
          viewBtn: this.vaildData(this.permission.billrecord_view, false),
          delBtn: this.vaildData(this.permission.billrecord_delete, false),
          editBtn: this.vaildData(this.permission.billrecord_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
